// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from marti_common_msgs:msg/ServiceHeader.idl
// generated code does not contain a copyright notice
#include "marti_common_msgs/msg/detail/service_header__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `stamp`
#include "builtin_interfaces/msg/detail/time__functions.h"
// Member `sender`
#include "rosidl_runtime_c/string_functions.h"

bool
marti_common_msgs__msg__ServiceHeader__init(marti_common_msgs__msg__ServiceHeader * msg)
{
  if (!msg) {
    return false;
  }
  // stamp
  if (!builtin_interfaces__msg__Time__init(&msg->stamp)) {
    marti_common_msgs__msg__ServiceHeader__fini(msg);
    return false;
  }
  // sequence
  // sender
  if (!rosidl_runtime_c__String__init(&msg->sender)) {
    marti_common_msgs__msg__ServiceHeader__fini(msg);
    return false;
  }
  // result
  return true;
}

void
marti_common_msgs__msg__ServiceHeader__fini(marti_common_msgs__msg__ServiceHeader * msg)
{
  if (!msg) {
    return;
  }
  // stamp
  builtin_interfaces__msg__Time__fini(&msg->stamp);
  // sequence
  // sender
  rosidl_runtime_c__String__fini(&msg->sender);
  // result
}

bool
marti_common_msgs__msg__ServiceHeader__are_equal(const marti_common_msgs__msg__ServiceHeader * lhs, const marti_common_msgs__msg__ServiceHeader * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // stamp
  if (!builtin_interfaces__msg__Time__are_equal(
      &(lhs->stamp), &(rhs->stamp)))
  {
    return false;
  }
  // sequence
  if (lhs->sequence != rhs->sequence) {
    return false;
  }
  // sender
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->sender), &(rhs->sender)))
  {
    return false;
  }
  // result
  if (lhs->result != rhs->result) {
    return false;
  }
  return true;
}

bool
marti_common_msgs__msg__ServiceHeader__copy(
  const marti_common_msgs__msg__ServiceHeader * input,
  marti_common_msgs__msg__ServiceHeader * output)
{
  if (!input || !output) {
    return false;
  }
  // stamp
  if (!builtin_interfaces__msg__Time__copy(
      &(input->stamp), &(output->stamp)))
  {
    return false;
  }
  // sequence
  output->sequence = input->sequence;
  // sender
  if (!rosidl_runtime_c__String__copy(
      &(input->sender), &(output->sender)))
  {
    return false;
  }
  // result
  output->result = input->result;
  return true;
}

marti_common_msgs__msg__ServiceHeader *
marti_common_msgs__msg__ServiceHeader__create(void)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  marti_common_msgs__msg__ServiceHeader * msg = (marti_common_msgs__msg__ServiceHeader *)allocator.allocate(sizeof(marti_common_msgs__msg__ServiceHeader), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(marti_common_msgs__msg__ServiceHeader));
  bool success = marti_common_msgs__msg__ServiceHeader__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
marti_common_msgs__msg__ServiceHeader__destroy(marti_common_msgs__msg__ServiceHeader * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    marti_common_msgs__msg__ServiceHeader__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
marti_common_msgs__msg__ServiceHeader__Sequence__init(marti_common_msgs__msg__ServiceHeader__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  marti_common_msgs__msg__ServiceHeader * data = NULL;

  if (size) {
    data = (marti_common_msgs__msg__ServiceHeader *)allocator.zero_allocate(size, sizeof(marti_common_msgs__msg__ServiceHeader), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = marti_common_msgs__msg__ServiceHeader__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        marti_common_msgs__msg__ServiceHeader__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
marti_common_msgs__msg__ServiceHeader__Sequence__fini(marti_common_msgs__msg__ServiceHeader__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      marti_common_msgs__msg__ServiceHeader__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

marti_common_msgs__msg__ServiceHeader__Sequence *
marti_common_msgs__msg__ServiceHeader__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  marti_common_msgs__msg__ServiceHeader__Sequence * array = (marti_common_msgs__msg__ServiceHeader__Sequence *)allocator.allocate(sizeof(marti_common_msgs__msg__ServiceHeader__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = marti_common_msgs__msg__ServiceHeader__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
marti_common_msgs__msg__ServiceHeader__Sequence__destroy(marti_common_msgs__msg__ServiceHeader__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    marti_common_msgs__msg__ServiceHeader__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
marti_common_msgs__msg__ServiceHeader__Sequence__are_equal(const marti_common_msgs__msg__ServiceHeader__Sequence * lhs, const marti_common_msgs__msg__ServiceHeader__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!marti_common_msgs__msg__ServiceHeader__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
marti_common_msgs__msg__ServiceHeader__Sequence__copy(
  const marti_common_msgs__msg__ServiceHeader__Sequence * input,
  marti_common_msgs__msg__ServiceHeader__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(marti_common_msgs__msg__ServiceHeader);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    marti_common_msgs__msg__ServiceHeader * data =
      (marti_common_msgs__msg__ServiceHeader *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!marti_common_msgs__msg__ServiceHeader__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          marti_common_msgs__msg__ServiceHeader__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!marti_common_msgs__msg__ServiceHeader__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
